diff -Naur openssl-1.0.0q.orig/crypto/objects/obj_dat.c openssl-1.0.0q/crypto/objects/obj_dat.c
--- openssl-1.0.0q.orig/crypto/objects/obj_dat.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/objects/obj_dat.c	2017-04-25 16:23:40.487620351 +0200
@@ -56,10 +56,12 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <ctype.h>
 #include <limits.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/lhash.h>
 #include <openssl/asn1.h>
 #include <openssl/objects.h>
@@ -74,15 +76,17 @@
 #define NUM_SN 0
 #define NUM_LN 0
 #define NUM_OBJ 0
-static const unsigned char lvalues[1];
+static const unsigned char lvalues[1];  /* ARRAY OK 2007-11-07 yngve UNUSED*/
 static const ASN1_OBJECT nid_objs[1];
 static const unsigned int sn_objs[1];
 static const unsigned int ln_objs[1];
 static const unsigned int obj_objs[1];
 #endif
 
+#ifndef OPERA_SMALL_VERSION
 DECLARE_OBJ_BSEARCH_CMP_FN(const ASN1_OBJECT *, unsigned int, sn);
 DECLARE_OBJ_BSEARCH_CMP_FN(const ASN1_OBJECT *, unsigned int, ln);
+#endif
 DECLARE_OBJ_BSEARCH_CMP_FN(const ASN1_OBJECT *, unsigned int, obj);
 
 #define ADDED_DATA	0
@@ -97,18 +101,31 @@
 	} ADDED_OBJ;
 DECLARE_LHASH_OF(ADDED_OBJ);
 
+#ifndef OPERA_SMALL_VERSION
+
 static int new_nid=NUM_NID;
 static LHASH_OF(ADDED_OBJ) *added=NULL;
 
+#else
+
+OPENSSL_DECLARE_GLOBAL(int,                   obj_dat__new_nid);
+#define new_nid OPENSSL_GLOBAL_REF(           obj_dat__new_nid)
+OPENSSL_DECLARE_GLOBAL(LHASH_OF(ADDED_OBJ) *, obj_dat__added);
+#define added OPENSSL_GLOBAL_REF(             obj_dat__added)
+
+#endif // !OPERA_SMALL_VERSION
+
+#ifndef OPERA_SMALL_VERSION
 static int sn_cmp(const ASN1_OBJECT * const *a, const unsigned int *b)
-	{ return(strcmp((*a)->sn,nid_objs[*b].sn)); }
+	{ return(op_strcmp((*a)->sn,nid_objs[*b].sn)); }
 
 IMPLEMENT_OBJ_BSEARCH_CMP_FN(const ASN1_OBJECT *, unsigned int, sn);
 
 static int ln_cmp(const ASN1_OBJECT * const *a, const unsigned int *b)
-	{ return(strcmp((*a)->ln,nid_objs[*b].ln)); }
+	{ return(op_strcmp((*a)->ln,nid_objs[*b].ln)); }
 
 IMPLEMENT_OBJ_BSEARCH_CMP_FN(const ASN1_OBJECT *, unsigned int, ln);
+#endif // !OPERA_SMALL_VERSION
 
 static unsigned long added_obj_hash(const ADDED_OBJ *ca)
 	{
@@ -159,15 +176,15 @@
 	case ADDED_DATA:
 		i=(a->length - b->length);
 		if (i) return(i);
-		return(memcmp(a->data,b->data,(size_t)a->length));
+		return(op_memcmp(a->data,b->data,(size_t)a->length));
 	case ADDED_SNAME:
 		if (a->sn == NULL) return(-1);
 		else if (b->sn == NULL) return(1);
-		else return(strcmp(a->sn,b->sn));
+		else return(op_strcmp(a->sn,b->sn));
 	case ADDED_LNAME:
 		if (a->ln == NULL) return(-1);
 		else if (b->ln == NULL) return(1);
-		else return(strcmp(a->ln,b->ln));
+		else return(op_strcmp(a->ln,b->ln));
 	case ADDED_NID:
 		return(a->nid-b->nid);
 	default:
@@ -288,8 +305,10 @@
 
 ASN1_OBJECT *OBJ_nid2obj(int n)
 	{
+#ifndef OPERA_SMALL_VERSION
 	ADDED_OBJ ad,*adp;
 	ASN1_OBJECT ob;
+#endif
 
 	if ((n >= 0) && (n < NUM_NID))
 		{
@@ -300,6 +319,10 @@
 			}
 		return((ASN1_OBJECT *)&(nid_objs[n]));
 		}
+#ifdef OPERA_SMALL_VERSION
+	else
+		return NULL;
+#else
 	else if (added == NULL)
 		return(NULL);
 	else
@@ -316,12 +339,15 @@
 			return(NULL);
 			}
 		}
+#endif // OPERA_SMALL_VERSION
 	}
 
 const char *OBJ_nid2sn(int n)
 	{
+#ifndef OPERA_SMALL_VERSION
 	ADDED_OBJ ad,*adp;
 	ASN1_OBJECT ob;
+#endif
 
 	if ((n >= 0) && (n < NUM_NID))
 		{
@@ -332,6 +358,10 @@
 			}
 		return(nid_objs[n].sn);
 		}
+#ifdef OPERA_SMALL_VERSION
+	else
+		return NULL;
+#else
 	else if (added == NULL)
 		return(NULL);
 	else
@@ -348,12 +378,15 @@
 			return(NULL);
 			}
 		}
+#endif // OPERA_SMALL_VERSION
 	}
 
 const char *OBJ_nid2ln(int n)
 	{
+#ifndef OPERA_SMALL_VERSION
 	ADDED_OBJ ad,*adp;
 	ASN1_OBJECT ob;
+#endif
 
 	if ((n >= 0) && (n < NUM_NID))
 		{
@@ -364,6 +397,10 @@
 			}
 		return(nid_objs[n].ln);
 		}
+#ifdef OPERA_SMALL_VERSION
+	else
+		return NULL;
+#else
 	else if (added == NULL)
 		return(NULL);
 	else
@@ -380,6 +417,7 @@
 			return(NULL);
 			}
 		}
+#endif // OPERA_SMALL_VERSION
 	}
 
 static int obj_cmp(const ASN1_OBJECT * const *ap, const unsigned int *bp)
@@ -390,7 +428,7 @@
 
 	j=(a->length - b->length);
         if (j) return(j);
-	return(memcmp(a->data,b->data,a->length));
+	return(op_memcmp(a->data,b->data,a->length));
 	}
 
 IMPLEMENT_OBJ_BSEARCH_CMP_FN(const ASN1_OBJECT *, unsigned int, obj);
@@ -398,13 +436,16 @@
 int OBJ_obj2nid(const ASN1_OBJECT *a)
 	{
 	const unsigned int *op;
+#ifndef OPERA_SMALL_VERSION
 	ADDED_OBJ ad,*adp;
+#endif // !OPERA_SMALL_VERSION
 
 	if (a == NULL)
 		return(NID_undef);
 	if (a->nid != 0)
 		return(a->nid);
 
+#ifndef OPERA_SMALL_VERSION
 	if (added != NULL)
 		{
 		ad.type=ADDED_DATA;
@@ -412,6 +453,7 @@
 		adp=lh_ADDED_OBJ_retrieve(added,&ad);
 		if (adp != NULL) return (adp->obj->nid);
 		}
+#endif // !OPERA_SMALL_VERSION
 	op=OBJ_bsearch_obj(&a, obj_objs, NUM_OBJ);
 	if (op == NULL)
 		return(NID_undef);
@@ -426,18 +468,22 @@
 
 ASN1_OBJECT *OBJ_txt2obj(const char *s, int no_name)
 	{
+#ifndef OPERA_SMALL_VERSION
 	int nid = NID_undef;
+#endif // !OPERA_SMALL_VERSION
 	ASN1_OBJECT *op=NULL;
 	unsigned char *buf;
 	unsigned char *p;
 	const unsigned char *cp;
 	int i, j;
 
+#ifndef OPERA_SMALL_VERSION
 	if(!no_name) {
 		if( ((nid = OBJ_sn2nid(s)) != NID_undef) ||
 			((nid = OBJ_ln2nid(s)) != NID_undef) ) 
 					return OBJ_nid2obj(nid);
 	}
+#endif // !OPERA_SMALL_VERSION
 
 	/* Work out size of content octets */
 	i=a2d_ASN1_OBJECT(NULL,0,s,-1);
@@ -469,7 +515,7 @@
 	BIGNUM *bl;
 	unsigned long l;
 	const unsigned char *p;
-	char tbuf[DECIMAL_SIZE(i)+DECIMAL_SIZE(l)+2];
+	char tbuf[DECIMAL_SIZE(i)+DECIMAL_SIZE(l)+2]; /* ARRAY OK 2009-05-25 yngve */
 
 	/* Ensure that, at every state, |buf| is NUL-terminated. */
 	if (buf && buf_len > 0)
@@ -488,7 +534,7 @@
 			{
 			if (buf)
 				BUF_strlcpy(buf,s,buf_len);
-			n=strlen(s);
+			n=op_strlen(s);
 			return n;
 			}
 		}
@@ -567,10 +613,10 @@
 		if (use_bn)
 			{
 			char *bndec;
-			bndec = BN_bn2dec(bl);
+			bndec = (char*) BN_bn2dec(bl);
 			if (!bndec)
 				goto err;
-			i = strlen(bndec);
+			i = op_strlen(bndec);
 			if (buf)
 				{
 				if (buf_len > 1)
@@ -598,7 +644,7 @@
 		else
 			{
 			BIO_snprintf(tbuf,sizeof tbuf,".%lu",l);
-			i=strlen(tbuf);
+			i=op_strlen(tbuf);
 			if (buf && (buf_len > 0))
 				{
 				BUF_strlcpy(buf,tbuf,buf_len);
@@ -617,7 +663,6 @@
 			l=0;
 			}
 		}
-
 	if (bl)
 		BN_free(bl);
 	return n;
@@ -628,6 +673,7 @@
 	return -1;
 }
 
+#ifndef OPERA_SMALL_VERSION
 int OBJ_txt2nid(const char *s)
 {
 	ASN1_OBJECT *obj;
@@ -642,10 +688,13 @@
 	{
 	ASN1_OBJECT o;
 	const ASN1_OBJECT *oo= &o;
+#ifndef OPERA_SMALL_VERSION
 	ADDED_OBJ ad,*adp;
+#endif // !OPERA_SMALL_VERSION
 	const unsigned int *op;
 
 	o.ln=s;
+#ifndef OPERA_SMALL_VERSION
 	if (added != NULL)
 		{
 		ad.type=ADDED_LNAME;
@@ -653,6 +702,7 @@
 		adp=lh_ADDED_OBJ_retrieve(added,&ad);
 		if (adp != NULL) return (adp->obj->nid);
 		}
+#endif // !OPERA_SMALL_VERSION
 	op=OBJ_bsearch_ln(&oo, ln_objs, NUM_LN);
 	if (op == NULL) return(NID_undef);
 	return(nid_objs[*op].nid);
@@ -662,10 +712,13 @@
 	{
 	ASN1_OBJECT o;
 	const ASN1_OBJECT *oo= &o;
+#ifndef OPERA_SMALL_VERSION
 	ADDED_OBJ ad,*adp;
+#endif // !OPERA_SMALL_VERSION
 	const unsigned int *op;
 
 	o.sn=s;
+#ifndef OPERA_SMALL_VERSION
 	if (added != NULL)
 		{
 		ad.type=ADDED_SNAME;
@@ -673,10 +726,12 @@
 		adp=lh_ADDED_OBJ_retrieve(added,&ad);
 		if (adp != NULL) return (adp->obj->nid);
 		}
+#endif // !OPERA_SMALL_VERSION
 	op=OBJ_bsearch_sn(&oo, sn_objs, NUM_SN);
 	if (op == NULL) return(NID_undef);
 	return(nid_objs[*op].nid);
 	}
+#endif // !OPERA_SMALL_VERSION
 
 const void *OBJ_bsearch_(const void *key, const void *base, int num, int size,
 			 int (*cmp)(const void *, const void *))
@@ -689,7 +744,7 @@
 			    int (*cmp)(const void *, const void *),
 			    int flags)
 	{
-	const char *base=base_;
+	const char *base=(const char *)base_;
 	int l,h,i=0,c=0;
 	const char *p = NULL;
 
@@ -735,9 +790,10 @@
 	return(p);
 	}
 
+#ifndef OPERA_SMALL_VERSION
 int OBJ_create_objects(BIO *in)
 	{
-	MS_STATIC char buf[512];
+	MS_STATIC char buf[512]; /* ARRAY OK 2007-11-07 yngve UNUSED */
 	int i,num=0;
 	char *o,*s,*l=NULL;
 
@@ -747,26 +803,26 @@
 		i=BIO_gets(in,buf,512);
 		if (i <= 0) return(num);
 		buf[i-1]='\0';
-		if (!isalnum((unsigned char)buf[0])) return(num);
+		if (!op_isalnum((unsigned char)buf[0])) return(num);
 		o=s=buf;
-		while (isdigit((unsigned char)*s) || (*s == '.'))
+		while (op_isdigit((unsigned char)*s) || (*s == '.'))
 			s++;
 		if (*s != '\0')
 			{
 			*(s++)='\0';
-			while (isspace((unsigned char)*s))
+			while (op_isspace((unsigned char)*s))
 				s++;
 			if (*s == '\0')
 				s=NULL;
 			else
 				{
 				l=s;
-				while ((*l != '\0') && !isspace((unsigned char)*l))
+				while ((*l != '\0') && !op_isspace((unsigned char)*l))
 					l++;
 				if (*l != '\0')
 					{
 					*(l++)='\0';
-					while (isspace((unsigned char)*l))
+					while (op_isspace((unsigned char)*l))
 						l++;
 					if (*l == '\0') l=NULL;
 					}
@@ -782,6 +838,7 @@
 		}
 	/* return(num); */
 	}
+#endif // !OPERA_SMALL_VERSION
 
 int OBJ_create(const char *oid, const char *sn, const char *ln)
 	{
diff -Naur openssl-1.0.0q.orig/crypto/objects/obj_dat.h openssl-1.0.0q/crypto/objects/obj_dat.h
--- openssl-1.0.0q.orig/crypto/objects/obj_dat.h	2015-01-15 15:56:15.000000000 +0100
+++ openssl-1.0.0q/crypto/objects/obj_dat.h	2017-04-25 16:23:40.527619848 +0200
@@ -1,5 +1,8 @@
 /* crypto/objects/obj_dat.h */
 
+/* !!NOTE!!NOTE!! MAKE NO DIRECT CHANGES IN THIS FILE.
+ * IT IS GENERATED; **ALL** CHANGES WILL BE LOST */
+
 /* THIS FILE IS GENERATED FROM objects.h by obj_dat.pl via the
  * following command:
  * perl obj_dat.pl obj_mac.h obj_dat.h
diff -Naur openssl-1.0.0q.orig/crypto/objects/obj_dat.pl openssl-1.0.0q/crypto/objects/obj_dat.pl
--- openssl-1.0.0q.orig/crypto/objects/obj_dat.pl	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/objects/obj_dat.pl	2017-04-25 16:23:40.528620254 +0200
@@ -94,7 +94,7 @@
 	{
 	if (!defined($nid{$i}))
 		{
-		push(@out,"{NULL,NULL,NID_undef,0,NULL,0},\n");
+		push(@out,"CONST_ENTRY_NID(NULL,NULL,NID_undef,0,NULL,0)\n");
 		}
 	else
 		{
@@ -111,7 +111,7 @@
 			$ln{$nid{$i}} = $sn;
 		}
 			
-		$out ="{";
+		$out ="CONST_ENTRY_NID(";
 		$out.="\"$sn\"";
 		$out.=","."\"$ln\"";
 		$out.=",NID_$nid{$i},";
@@ -125,13 +125,13 @@
 			$length=0;
 			foreach (unpack("C*",$r))
 				{
-				$z.=sprintf("0x%02X,",$_);
+				$z.=sprintf("I(0x%02X) ",$_);
 				$length++;
 				}
 			$obj_der{$obj{$nid{$i}}}=$z;
 			$obj_len{$obj{$nid{$i}}}=$length;
 
-			push(@lvalues,sprintf("%-45s/* [%3d] %s */\n",
+			push(@lvalues,sprintf("%-55s/* [%3d] %s */\n",
 				$z,$lvalues,$obj{$nid{$i}}));
 			$out.="$length,&(lvalues[$lvalues]),0";
 			$lvalues+=$length;
@@ -140,7 +140,7 @@
 			{
 			$out.="0,NULL,0";
 			}
-		$out.="},\n";
+		$out.=")\n";
 		push(@out,$out);
 		}
 	}
@@ -148,13 +148,13 @@
 @a=grep(defined($sn{$nid{$_}}),0 .. $n);
 foreach (sort { $sn{$nid{$a}} cmp $sn{$nid{$b}} } @a)
 	{
-	push(@sn,sprintf("%2d,\t/* \"$sn{$nid{$_}}\" */\n",$_));
+	push(@sn,sprintf("CONST_ENTRY(%2d)\t/* \"$sn{$nid{$_}}\" */\n",$_));
 	}
 
 @a=grep(defined($ln{$nid{$_}}),0 .. $n);
 foreach (sort { $ln{$nid{$a}} cmp $ln{$nid{$b}} } @a)
 	{
-	push(@ln,sprintf("%2d,\t/* \"$ln{$nid{$_}}\" */\n",$_));
+	push(@ln,sprintf("CONST_ENTRY(%2d)\t/* \"$ln{$nid{$_}}\" */\n",$_));
 	}
 
 @a=grep(defined($obj{$nid{$_}}),0 .. $n);
@@ -164,12 +164,15 @@
 	$v=$objd{$m};
 	$v =~ s/L//g;
 	$v =~ s/,/ /g;
-	push(@ob,sprintf("%2d,\t/* %-32s %s */\n",$_,$m,$v));
+	push(@ob,sprintf("CONST_ENTRY(%2d)\t/* %-32s %s */\n",$_,$m,$v));
 	}
 
 print OUT <<'EOF';
 /* crypto/objects/obj_dat.h */
 
+/* !!NOTE!!NOTE!! MAKE NO DIRECT CHANGES IN THIS FILE.
+ * IT IS GENERATED; **ALL** CHANGES WILL BE LOST */
+
 /* THIS FILE IS GENERATED FROM objects.h by obj_dat.pl via the
  * following command:
  * perl obj_dat.pl obj_mac.h obj_dat.h
@@ -232,6 +235,34 @@
  * [including the GNU Public Licence.]
  */
 
+#include "modules/libopeay/libopeay_arrays.h"
+#include "modules/libopeay/libopeay_implmodule.h"
+
+#define CONST_ENTRY_NID(_sn, _ln, _nid, len, _dat, _flg) \
+	CONST_ENTRY_START(sn, _sn)\
+	CONST_ENTRY_SINGLE(ln, _ln)\
+	CONST_ENTRY_SINGLE(nid, _nid)\
+	CONST_ENTRY_SINGLE(length, len)\
+	CONST_ENTRY_SINGLE(data, _dat)\
+	CONST_ENTRY_SINGLE(flags, _flg)\
+	CONST_ENTRY_END
+
+#ifndef ADS12
+#define LVALUES_START static const unsigned char lvalues[]={
+#define I(x) x,
+#define LVALUES_END };
+#else
+#define LVALUES_START OPENSSL_PREFIX_CONST_ARRAY(static, unsigned char, lvalues, libopeay)
+#define I(x) CONST_ENTRY(x)
+#define LVALUES_END CONST_END(lvalues)
+#define NEED_LVALUES_OVERRIDE
+#endif
+
+/* These arrays become too big for some compilers, e.g MSDev 6. In any case their size is under control */
+#undef TEST_CONST_ARRAY_SIZE
+#define TEST_CONST_ARRAY_SIZE ((void)0)
+
+
 EOF
 
 printf OUT "#define NUM_NID %d\n",$n;
@@ -239,20 +270,28 @@
 printf OUT "#define NUM_LN %d\n",$#ln+1;
 printf OUT "#define NUM_OBJ %d\n\n",$#ob+1;
 
-printf OUT "static const unsigned char lvalues[%d]={\n",$lvalues+1;
+print OUT "LVALUES_START\n";
 print OUT @lvalues;
-print OUT "};\n\n";
+print OUT <<'EOF';
+LVALUES_END
 
-printf OUT "static const ASN1_OBJECT nid_objs[NUM_NID]={\n";
+#ifdef NEED_LVALUES_OVERRIDE
+// Some compilers (e.g. ADS) expands macros differently from most other compilers, so this have to be declared down here
+#define lvalues OPENSSL_GLOBAL_ARRAY_NAME(lvalues)
+#endif
+
+EOF
+
+printf OUT "OPENSSL_PREFIX_CONST_ARRAY(static, ASN1_OBJECT, nid_objs, libopeay)\n";
 foreach (@out)
 	{
-	if (length($_) > 75)
+	if (length($_) >=90)
 		{
 		$out="";
 		foreach (split(/,/))
 			{
 			$t=$out.$_.",";
-			if (length($t) > 70)
+			if (length($t) > 85)
 				{
 				print OUT "$out\n";
 				$t="\t$_,";
@@ -265,19 +304,37 @@
 	else
 		{ print OUT $_; }
 	}
-print  OUT "};\n\n";
 
-printf OUT "static const unsigned int sn_objs[NUM_SN]={\n";
+print OUT <<'EOF';
+CONST_END(nid_objs);
+
+#define nid_objs OPENSSL_GLOBAL_ARRAY_NAME(nid_objs)
+
+EOF
+
+printf OUT "#ifndef OPERA_SMALL_VERSION\n";
+printf OUT "OPENSSL_PREFIX_CONST_ARRAY(static, unsigned int, sn_objs, libopeay)\n";
 print  OUT @sn;
-print  OUT "};\n\n";
+print  OUT "CONST_END(sn_objs)\n\n";
+printf OUT "#endif // !OPERA_SMALL_VERSION\n\n";
 
-printf OUT "static const unsigned int ln_objs[NUM_LN]={\n";
+printf OUT "#ifndef OPERA_SMALL_VERSION\n";
+printf OUT "OPENSSL_PREFIX_CONST_ARRAY(static, unsigned int, ln_objs, libopeay)\n";
 print  OUT @ln;
-print  OUT "};\n\n";
+print  OUT "CONST_END(ln_objs)\n";
+printf OUT "#endif // !OPERA_SMALL_VERSION\n\n";
 
-printf OUT "static const unsigned int obj_objs[NUM_OBJ]={\n";
+printf OUT "OPENSSL_PREFIX_CONST_ARRAY(static, unsigned int, obj_objs, libopeay)\n";
 print  OUT @ob;
-print  OUT "};\n\n";
+print  OUT "CONST_END(obj_objs)\n\n";
+
+print OUT <<'EOF';
+
+#define sn_objs OPENSSL_GLOBAL_ARRAY_NAME(sn_objs)
+#define ln_objs OPENSSL_GLOBAL_ARRAY_NAME(ln_objs)
+#define obj_objs OPENSSL_GLOBAL_ARRAY_NAME(obj_objs)
+
+EOF
 
 close OUT;
 
diff -Naur openssl-1.0.0q.orig/crypto/objects/obj_err.c openssl-1.0.0q/crypto/objects/obj_err.c
--- openssl-1.0.0q.orig/crypto/objects/obj_err.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/objects/obj_err.c	2017-04-25 16:23:40.529620940 +0200
@@ -58,7 +58,9 @@
  * only reason strings will be preserved.
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/err.h>
 #include <openssl/objects.h>
 
diff -Naur openssl-1.0.0q.orig/crypto/objects/obj_lib.c openssl-1.0.0q/crypto/objects/obj_lib.c
--- openssl-1.0.0q.orig/crypto/objects/obj_lib.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/objects/obj_lib.c	2017-04-25 16:23:40.530620509 +0200
@@ -56,8 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/lhash.h>
 #include <openssl/objects.h>
 #include <openssl/buffer.h>
@@ -80,11 +82,11 @@
 		OBJerr(OBJ_F_OBJ_DUP,ERR_R_ASN1_LIB);
 		return(NULL);
 		}
-	data=OPENSSL_malloc(o->length);
+	data= (unsigned char *) OPENSSL_malloc(o->length);
 	if (data == NULL)
 		goto err;
 	if (o->data != NULL)
-		memcpy(data,o->data,o->length);
+		op_memcpy(data,o->data,o->length);
 	/* once data attached to object it remains const */
 	r->data = data;
 	r->length=o->length;
@@ -92,19 +94,19 @@
 	r->ln=r->sn=NULL;
 	if (o->ln != NULL)
 		{
-		i=strlen(o->ln)+1;
-		ln=OPENSSL_malloc(i);
+		i=op_strlen(o->ln)+1;
+		ln= (char *) OPENSSL_malloc(i);
 		if (ln == NULL) goto err;
-		memcpy(ln,o->ln,i);
+		op_memcpy(ln,o->ln,i);
 		r->ln=ln;
 		}
 
 	if (o->sn != NULL)
 		{
-		i=strlen(o->sn)+1;
-		sn=OPENSSL_malloc(i);
+		i=op_strlen(o->sn)+1;
+		sn= (char *) OPENSSL_malloc(i);
 		if (sn == NULL) goto err;
-		memcpy(sn,o->sn,i);
+		op_memcpy(sn,o->sn,i);
 		r->sn=sn;
 		}
 	r->flags=o->flags|(ASN1_OBJECT_FLAG_DYNAMIC|
@@ -125,5 +127,5 @@
 
 	ret=(a->length-b->length);
 	if (ret) return(ret);
-	return(memcmp(a->data,b->data,a->length));
+	return(op_memcmp(a->data,b->data,a->length));
 	}
diff -Naur openssl-1.0.0q.orig/crypto/objects/obj_xref.c openssl-1.0.0q/crypto/objects/obj_xref.c
--- openssl-1.0.0q.orig/crypto/objects/obj_xref.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/objects/obj_xref.c	2017-04-25 16:23:40.531620077 +0200
@@ -58,6 +58,8 @@
 
 #include <openssl/objects.h>
 #include "obj_xref.h"
+#include "modules/libopeay/libopeay_arrays.h"
+
 
 DECLARE_STACK_OF(nid_triple)
 STACK_OF(nid_triple) *sig_app, *sigx_app;
@@ -105,7 +107,7 @@
 	if (rv == NULL)
 		{
 		rv = OBJ_bsearch_sig(&tmp, sigoid_srt,
-				 sizeof(sigoid_srt) / sizeof(nid_triple));
+				OPENSSL_CONST_ARRAY_SIZE(obj_xref__sigoid_srt));
 		}
 #endif
 	if (rv == NULL)
@@ -138,7 +140,7 @@
 	if (rv == NULL)
 		{
 		rv = OBJ_bsearch_sigx(&t, sigoid_srt_xref,
-				 sizeof(sigoid_srt_xref) / sizeof(nid_triple *)
+				OPENSSL_CONST_ARRAY_SIZE(obj_xref__sigoid_srt_xref)
 				 );
 		}
 #endif
@@ -159,7 +161,7 @@
 		sigx_app = sk_nid_triple_new(sigx_cmp);
 	if (!sigx_app)
 		return 0;
-	ntr = OPENSSL_malloc(sizeof(int) * 3);
+	ntr = (nid_triple *)OPENSSL_malloc(sizeof(int) * 3);
 	if (!ntr)
 		return 0;
 	ntr->sign_id = signid;
@@ -208,14 +210,14 @@
 
 	int i, rv;
 #ifdef OBJ_XREF_TEST2
-	for (i = 0; i <	sizeof(sigoid_srt) / sizeof(nid_triple); i++)
+	for (i = 0; i <	OPENSSL_CONST_ARRAY_SIZE(obj_xref__sigoid_srt); i++)
 		{
 		OBJ_add_sigid(sigoid_srt[i][0], sigoid_srt[i][1],
 				sigoid_srt[i][2]);
 		}
 #endif
 
-	for (i = 0; i <	sizeof(sigoid_srt) / sizeof(nid_triple); i++)
+	for (i = 0; i <	OPENSSL_CONST_ARRAY_SIZE(obj_xref__sigoid_srt); i++)
 		{
 		n1 = sigoid_srt[i][0];
 		rv = OBJ_find_sigid_algs(n1, &n2, &n3);
diff -Naur openssl-1.0.0q.orig/crypto/objects/objects.h openssl-1.0.0q/crypto/objects/objects.h
--- openssl-1.0.0q.orig/crypto/objects/objects.h	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/objects/objects.h	2017-04-25 16:23:40.533620890 +0200
@@ -1058,8 +1058,8 @@
 #define IMPLEMENT_OBJ_BSEARCH_CMP_FN(type1, type2, nm)	\
   static int nm##_cmp_BSEARCH_CMP_FN(const void *a_, const void *b_)	\
       { \
-      type1 const *a = a_; \
-      type2 const *b = b_; \
+      type1 const *a = (type1 const *) a_; \
+      type2 const *b = (type2 const *) b_; \
       return nm##_cmp(a,b); \
       } \
   static type2 *OBJ_bsearch_##nm(type1 *key, type2 const *base, int num) \
@@ -1072,8 +1072,8 @@
 #define IMPLEMENT_OBJ_BSEARCH_GLOBAL_CMP_FN(type1, type2, nm)	\
   static int nm##_cmp_BSEARCH_CMP_FN(const void *a_, const void *b_)	\
       { \
-      type1 const *a = a_; \
-      type2 const *b = b_; \
+      type1 const *a = (type1 const *)a_; \
+      type2 const *b = (type2 const *)b_; \
       return nm##_cmp(a,b); \
       } \
   type2 *OBJ_bsearch_##nm(type1 *key, type2 const *base, int num) \
diff -Naur openssl-1.0.0q.orig/crypto/ocsp/.gitignore openssl-1.0.0q/crypto/ocsp/.gitignore
--- openssl-1.0.0q.orig/crypto/ocsp/.gitignore	1970-01-01 01:00:00.000000000 +0100
+++ openssl-1.0.0q/crypto/ocsp/.gitignore	2017-04-25 16:23:40.537619722 +0200
@@ -0,0 +1,2 @@
+/.depend
+/*.d
diff -Naur openssl-1.0.0q.orig/crypto/ocsp/ocsp.h openssl-1.0.0q/crypto/ocsp/ocsp.h
--- openssl-1.0.0q.orig/crypto/ocsp/ocsp.h	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/ocsp/ocsp.h	2017-04-25 16:23:40.538620967 +0200
@@ -64,6 +64,11 @@
 #ifndef HEADER_OCSP_H
 #define HEADER_OCSP_H
 
+#ifdef OPENSSL_SYS_WIN32
+#undef OCSP_REQUEST
+#undef OCSP_RESPONSE
+#endif
+
 #include <openssl/ossl_typ.h>
 #include <openssl/x509.h>
 #include <openssl/x509v3.h>
diff -Naur openssl-1.0.0q.orig/crypto/ocsp/ocsp_asn.c openssl-1.0.0q/crypto/ocsp/ocsp_asn.c
--- openssl-1.0.0q.orig/crypto/ocsp/ocsp_asn.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/ocsp/ocsp_asn.c	2017-04-25 16:23:40.539620535 +0200
@@ -55,128 +55,152 @@
  * Hudson (tjh@cryptsoft.com).
  *
  */
+
+
+#include <openssl/cryptlib.h>
 #include <openssl/asn1.h>
 #include <openssl/asn1t.h>
 #include <openssl/ocsp.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
-ASN1_SEQUENCE(OCSP_SIGNATURE) = {
-	ASN1_SIMPLE(OCSP_SIGNATURE, signatureAlgorithm, X509_ALGOR),
-	ASN1_SIMPLE(OCSP_SIGNATURE, signature, ASN1_BIT_STRING),
+#ifndef OPENSSL_NO_OCSP
+
+ASN1_SEQUENCE(OCSP_SIGNATURE) 
+	ASN1_SIMPLE(OCSP_SIGNATURE, signatureAlgorithm, X509_ALGOR)
+	ASN1_SIMPLE(OCSP_SIGNATURE, signature, ASN1_BIT_STRING)
 	ASN1_EXP_SEQUENCE_OF_OPT(OCSP_SIGNATURE, certs, X509, 0)
-} ASN1_SEQUENCE_END(OCSP_SIGNATURE)
+ASN1_SEQUENCE_END(OCSP_SIGNATURE)
 
-IMPLEMENT_ASN1_FUNCTIONS(OCSP_SIGNATURE)
+IMPLEMENT_ASN1_FUNCTIONS31(OCSP_SIGNATURE)
 
-ASN1_SEQUENCE(OCSP_CERTID) = {
-	ASN1_SIMPLE(OCSP_CERTID, hashAlgorithm, X509_ALGOR),
-	ASN1_SIMPLE(OCSP_CERTID, issuerNameHash, ASN1_OCTET_STRING),
-	ASN1_SIMPLE(OCSP_CERTID, issuerKeyHash, ASN1_OCTET_STRING),
+ASN1_SEQUENCE(OCSP_CERTID) 
+	ASN1_SIMPLE(OCSP_CERTID, hashAlgorithm, X509_ALGOR)
+	ASN1_SIMPLE(OCSP_CERTID, issuerNameHash, ASN1_OCTET_STRING)
+	ASN1_SIMPLE(OCSP_CERTID, issuerKeyHash, ASN1_OCTET_STRING)
 	ASN1_SIMPLE(OCSP_CERTID, serialNumber, ASN1_INTEGER)
-} ASN1_SEQUENCE_END(OCSP_CERTID)
+ASN1_SEQUENCE_END(OCSP_CERTID)
 
-IMPLEMENT_ASN1_FUNCTIONS(OCSP_CERTID)
+IMPLEMENT_ASN1_FUNCTIONS3(OCSP_CERTID)
 
-ASN1_SEQUENCE(OCSP_ONEREQ) = {
-	ASN1_SIMPLE(OCSP_ONEREQ, reqCert, OCSP_CERTID),
+ASN1_SEQUENCE(OCSP_ONEREQ) 
+	ASN1_SIMPLE(OCSP_ONEREQ, reqCert, OCSP_CERTID)
 	ASN1_EXP_SEQUENCE_OF_OPT(OCSP_ONEREQ, singleRequestExtensions, X509_EXTENSION, 0)
-} ASN1_SEQUENCE_END(OCSP_ONEREQ)
+ASN1_SEQUENCE_END(OCSP_ONEREQ)
 
-IMPLEMENT_ASN1_FUNCTIONS(OCSP_ONEREQ)
+IMPLEMENT_ASN1_FUNCTIONS3(OCSP_ONEREQ)
 
-ASN1_SEQUENCE(OCSP_REQINFO) = {
-	ASN1_EXP_OPT(OCSP_REQINFO, version, ASN1_INTEGER, 0),
-	ASN1_EXP_OPT(OCSP_REQINFO, requestorName, GENERAL_NAME, 1),
-	ASN1_SEQUENCE_OF(OCSP_REQINFO, requestList, OCSP_ONEREQ),
+ASN1_SEQUENCE(OCSP_REQINFO) 
+	ASN1_EXP_OPT(OCSP_REQINFO, version, ASN1_INTEGER, 0)
+	ASN1_EXP_OPT(OCSP_REQINFO, requestorName, GENERAL_NAME, 1)
+	ASN1_SEQUENCE_OF(OCSP_REQINFO, requestList, OCSP_ONEREQ)
 	ASN1_EXP_SEQUENCE_OF_OPT(OCSP_REQINFO, requestExtensions, X509_EXTENSION, 2)
-} ASN1_SEQUENCE_END(OCSP_REQINFO)
+ASN1_SEQUENCE_END(OCSP_REQINFO)
 
+#ifndef OPERA_SMALL_VERSION
 IMPLEMENT_ASN1_FUNCTIONS(OCSP_REQINFO)
+#endif
 
-ASN1_SEQUENCE(OCSP_REQUEST) = {
-	ASN1_SIMPLE(OCSP_REQUEST, tbsRequest, OCSP_REQINFO),
+ASN1_SEQUENCE(OCSP_REQUEST) 
+	ASN1_SIMPLE(OCSP_REQUEST, tbsRequest, OCSP_REQINFO)
 	ASN1_EXP_OPT(OCSP_REQUEST, optionalSignature, OCSP_SIGNATURE, 0)
-} ASN1_SEQUENCE_END(OCSP_REQUEST)
+ASN1_SEQUENCE_END(OCSP_REQUEST)
 
-IMPLEMENT_ASN1_FUNCTIONS(OCSP_REQUEST)
+IMPLEMENT_ASN1_FUNCTIONS1(OCSP_REQUEST)
 
 /* OCSP_RESPONSE templates */
 
-ASN1_SEQUENCE(OCSP_RESPBYTES) = {
-	    ASN1_SIMPLE(OCSP_RESPBYTES, responseType, ASN1_OBJECT),
+ASN1_SEQUENCE(OCSP_RESPBYTES) 
+	    ASN1_SIMPLE(OCSP_RESPBYTES, responseType, ASN1_OBJECT)
 	    ASN1_SIMPLE(OCSP_RESPBYTES, response, ASN1_OCTET_STRING)
-} ASN1_SEQUENCE_END(OCSP_RESPBYTES)
+ASN1_SEQUENCE_END(OCSP_RESPBYTES)
 
+#ifndef OPERA_SMALL_VERSION
 IMPLEMENT_ASN1_FUNCTIONS(OCSP_RESPBYTES)
+#endif
 
-ASN1_SEQUENCE(OCSP_RESPONSE) = {
-	ASN1_SIMPLE(OCSP_RESPONSE, responseStatus, ASN1_ENUMERATED),
+ASN1_SEQUENCE(OCSP_RESPONSE) 
+	ASN1_SIMPLE(OCSP_RESPONSE, responseStatus, ASN1_ENUMERATED)
 	ASN1_EXP_OPT(OCSP_RESPONSE, responseBytes, OCSP_RESPBYTES, 0)
-} ASN1_SEQUENCE_END(OCSP_RESPONSE)
+ASN1_SEQUENCE_END(OCSP_RESPONSE)
 
-IMPLEMENT_ASN1_FUNCTIONS(OCSP_RESPONSE)
+IMPLEMENT_ASN1_FUNCTIONS2(OCSP_RESPONSE)
 
-ASN1_CHOICE(OCSP_RESPID) = {
-	   ASN1_EXP(OCSP_RESPID, value.byName, X509_NAME, 1),
+ASN1_CHOICE(OCSP_RESPID)
+	   ASN1_EXP(OCSP_RESPID, value.byName, X509_NAME, 1)
 	   ASN1_EXP(OCSP_RESPID, value.byKey, ASN1_OCTET_STRING, 2)
-} ASN1_CHOICE_END(OCSP_RESPID)
+ASN1_CHOICE_END(OCSP_RESPID)
 
 IMPLEMENT_ASN1_FUNCTIONS(OCSP_RESPID)
 
-ASN1_SEQUENCE(OCSP_REVOKEDINFO) = {
-	ASN1_SIMPLE(OCSP_REVOKEDINFO, revocationTime, ASN1_GENERALIZEDTIME),
+ASN1_SEQUENCE(OCSP_REVOKEDINFO)
+	ASN1_SIMPLE(OCSP_REVOKEDINFO, revocationTime, ASN1_GENERALIZEDTIME)
   	ASN1_EXP_OPT(OCSP_REVOKEDINFO, revocationReason, ASN1_ENUMERATED, 0)
-} ASN1_SEQUENCE_END(OCSP_REVOKEDINFO)
+ASN1_SEQUENCE_END(OCSP_REVOKEDINFO)
 
+#ifndef OPERA_SMALL_VERSION
 IMPLEMENT_ASN1_FUNCTIONS(OCSP_REVOKEDINFO)
+#endif
 
-ASN1_CHOICE(OCSP_CERTSTATUS) = {
-	ASN1_IMP(OCSP_CERTSTATUS, value.good, ASN1_NULL, 0),
-	ASN1_IMP(OCSP_CERTSTATUS, value.revoked, OCSP_REVOKEDINFO, 1),
+ASN1_CHOICE(OCSP_CERTSTATUS)
+	ASN1_IMP(OCSP_CERTSTATUS, value.good, ASN1_NULL, 0)
+	ASN1_IMP(OCSP_CERTSTATUS, value.revoked, OCSP_REVOKEDINFO, 1)
 	ASN1_IMP(OCSP_CERTSTATUS, value.unknown, ASN1_NULL, 2)
-} ASN1_CHOICE_END(OCSP_CERTSTATUS)
+ASN1_CHOICE_END(OCSP_CERTSTATUS)
 
+#ifndef OPERA_SMALL_VERSION
 IMPLEMENT_ASN1_FUNCTIONS(OCSP_CERTSTATUS)
+#endif
 
-ASN1_SEQUENCE(OCSP_SINGLERESP) = {
-	   ASN1_SIMPLE(OCSP_SINGLERESP, certId, OCSP_CERTID),
-	   ASN1_SIMPLE(OCSP_SINGLERESP, certStatus, OCSP_CERTSTATUS),
-	   ASN1_SIMPLE(OCSP_SINGLERESP, thisUpdate, ASN1_GENERALIZEDTIME),
-	   ASN1_EXP_OPT(OCSP_SINGLERESP, nextUpdate, ASN1_GENERALIZEDTIME, 0),
+ASN1_SEQUENCE(OCSP_SINGLERESP) 
+	   ASN1_SIMPLE(OCSP_SINGLERESP, certId, OCSP_CERTID)
+	   ASN1_SIMPLE(OCSP_SINGLERESP, certStatus, OCSP_CERTSTATUS)
+	   ASN1_SIMPLE(OCSP_SINGLERESP, thisUpdate, ASN1_GENERALIZEDTIME)
+	   ASN1_EXP_OPT(OCSP_SINGLERESP, nextUpdate, ASN1_GENERALIZEDTIME, 0)
 	   ASN1_EXP_SEQUENCE_OF_OPT(OCSP_SINGLERESP, singleExtensions, X509_EXTENSION, 1)
-} ASN1_SEQUENCE_END(OCSP_SINGLERESP)
+ASN1_SEQUENCE_END(OCSP_SINGLERESP)
 
+#ifndef OPERA_SMALL_VERSION
 IMPLEMENT_ASN1_FUNCTIONS(OCSP_SINGLERESP)
+#endif
 
-ASN1_SEQUENCE(OCSP_RESPDATA) = {
-	   ASN1_EXP_OPT(OCSP_RESPDATA, version, ASN1_INTEGER, 0),
-	   ASN1_SIMPLE(OCSP_RESPDATA, responderId, OCSP_RESPID),
-	   ASN1_SIMPLE(OCSP_RESPDATA, producedAt, ASN1_GENERALIZEDTIME),
-	   ASN1_SEQUENCE_OF(OCSP_RESPDATA, responses, OCSP_SINGLERESP),
+ASN1_SEQUENCE(OCSP_RESPDATA) 
+	   ASN1_EXP_OPT(OCSP_RESPDATA, version, ASN1_INTEGER, 0)
+	   ASN1_SIMPLE(OCSP_RESPDATA, responderId, OCSP_RESPID)
+	   ASN1_SIMPLE(OCSP_RESPDATA, producedAt, ASN1_GENERALIZEDTIME)
+	   ASN1_SEQUENCE_OF(OCSP_RESPDATA, responses, OCSP_SINGLERESP)
 	   ASN1_EXP_SEQUENCE_OF_OPT(OCSP_RESPDATA, responseExtensions, X509_EXTENSION, 1)
-} ASN1_SEQUENCE_END(OCSP_RESPDATA)
+ASN1_SEQUENCE_END(OCSP_RESPDATA)
 
+#ifndef OPERA_SMALL_VERSION
 IMPLEMENT_ASN1_FUNCTIONS(OCSP_RESPDATA)
+#endif
 
-ASN1_SEQUENCE(OCSP_BASICRESP) = {
-	   ASN1_SIMPLE(OCSP_BASICRESP, tbsResponseData, OCSP_RESPDATA),
-	   ASN1_SIMPLE(OCSP_BASICRESP, signatureAlgorithm, X509_ALGOR),
-	   ASN1_SIMPLE(OCSP_BASICRESP, signature, ASN1_BIT_STRING),
+ASN1_SEQUENCE(OCSP_BASICRESP) 
+	   ASN1_SIMPLE(OCSP_BASICRESP, tbsResponseData, OCSP_RESPDATA)
+	   ASN1_SIMPLE(OCSP_BASICRESP, signatureAlgorithm, X509_ALGOR)
+	   ASN1_SIMPLE(OCSP_BASICRESP, signature, ASN1_BIT_STRING)
 	   ASN1_EXP_SEQUENCE_OF_OPT(OCSP_BASICRESP, certs, X509, 0)
-} ASN1_SEQUENCE_END(OCSP_BASICRESP)
+ASN1_SEQUENCE_END(OCSP_BASICRESP)
 
-IMPLEMENT_ASN1_FUNCTIONS(OCSP_BASICRESP)
+IMPLEMENT_ASN1_FUNCTIONS3(OCSP_BASICRESP)
 
-ASN1_SEQUENCE(OCSP_CRLID) = {
-	   ASN1_EXP_OPT(OCSP_CRLID, crlUrl, ASN1_IA5STRING, 0),
-	   ASN1_EXP_OPT(OCSP_CRLID, crlNum, ASN1_INTEGER, 1),
+ASN1_SEQUENCE(OCSP_CRLID) 
+	   ASN1_EXP_OPT(OCSP_CRLID, crlUrl, ASN1_IA5STRING, 0)
+	   ASN1_EXP_OPT(OCSP_CRLID, crlNum, ASN1_INTEGER, 1)
 	   ASN1_EXP_OPT(OCSP_CRLID, crlTime, ASN1_GENERALIZEDTIME, 2)
-} ASN1_SEQUENCE_END(OCSP_CRLID)
+ASN1_SEQUENCE_END(OCSP_CRLID)
 
+#ifndef OPERA_SMALL_VERSION
 IMPLEMENT_ASN1_FUNCTIONS(OCSP_CRLID)
+#endif
 
-ASN1_SEQUENCE(OCSP_SERVICELOC) = {
-	ASN1_SIMPLE(OCSP_SERVICELOC, issuer, X509_NAME),
+ASN1_SEQUENCE(OCSP_SERVICELOC) 
+	ASN1_SIMPLE(OCSP_SERVICELOC, issuer, X509_NAME)
 	ASN1_SEQUENCE_OF_OPT(OCSP_SERVICELOC, locator, ACCESS_DESCRIPTION)
-} ASN1_SEQUENCE_END(OCSP_SERVICELOC)
+ASN1_SEQUENCE_END(OCSP_SERVICELOC)
 
+#ifndef OPERA_SMALL_VERSION
 IMPLEMENT_ASN1_FUNCTIONS(OCSP_SERVICELOC)
+#endif
+
+#endif /* OPENSSL_NO_OCSP */
diff -Naur openssl-1.0.0q.orig/crypto/ocsp/ocsp_cl.c openssl-1.0.0q/crypto/ocsp/ocsp_cl.c
--- openssl-1.0.0q.orig/crypto/ocsp/ocsp_cl.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/ocsp/ocsp_cl.c	2017-04-25 16:23:40.541620789 +0200
@@ -61,15 +61,21 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <time.h>
-#include <cryptlib.h>
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
+
+#ifndef OPENSSL_NO_OCSP
+
 #include <openssl/objects.h>
 #include <openssl/rand.h>
 #include <openssl/x509.h>
 #include <openssl/pem.h>
 #include <openssl/x509v3.h>
 #include <openssl/ocsp.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
 /* Utility functions related to sending OCSP requests and extracting
  * relevant information from the response.
@@ -95,6 +101,7 @@
 	return NULL;
         }
 
+#ifndef OPERA_SMALL_VERSION
 /* Set requestorName from an X509_NAME structure */
 
 int OCSP_request_set1_name(OCSP_REQUEST *req, X509_NAME *nm)
@@ -181,6 +188,7 @@
 	req->optionalSignature = NULL;
 	return 0;
 	}
+#endif /* OPERA_SMALL_VERSION */
 
 /* Get response status */
 
@@ -209,18 +217,20 @@
 		return NULL;
 		}
 
-	return ASN1_item_unpack(rb->response, ASN1_ITEM_rptr(OCSP_BASICRESP));
+	return (OCSP_BASICRESP *) ASN1_item_unpack(rb->response, ASN1_ITEM_rptr(OCSP_BASICRESP));
 	}
 
 /* Return number of OCSP_SINGLERESP reponses present in
  * a basic response.
  */
 
+#ifndef OPERA_SMALL_VERSION
 int OCSP_resp_count(OCSP_BASICRESP *bs)
 	{
 	if (!bs) return -1;
 	return sk_OCSP_SINGLERESP_num(bs->tbsResponseData->responses);
 	}
+#endif /* OPERA_SMALL_VERSION */
 
 /* Extract an OCSP_SINGLERESP response with a given index */
 
@@ -313,7 +323,7 @@
 	{
 	int ret = 1;
 	time_t t_now, t_tmp;
-	time(&t_now);
+	op_time(&t_now);
 	/* Check thisUpdate is valid and not more than nsec in the future */
 	if (!ASN1_GENERALIZEDTIME_check(thisupd))
 		{
@@ -369,3 +379,5 @@
 
 	return ret;
 	}
+
+#endif /* OPENSSL_NO_OCSP */
diff -Naur openssl-1.0.0q.orig/crypto/ocsp/ocsp_err.c openssl-1.0.0q/crypto/ocsp/ocsp_err.c
--- openssl-1.0.0q.orig/crypto/ocsp/ocsp_err.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/ocsp/ocsp_err.c	2017-04-25 16:23:40.542620637 +0200
@@ -58,7 +58,9 @@
  * only reason strings will be preserved.
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <openssl/err.h>
 #include <openssl/ocsp.h>
 
